SystemOrganization addCategory: #'Phidget-Mock'!

PhdCrPhidget subclass: #PhdMockPhidget
	instanceVariableNames: 'attached'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

PhdMockPhidget class
	instanceVariableNames: 'currentId'!

PhdMockPhidget class
	instanceVariableNames: 'currentId'!

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:33'!
getPhidgetFromId: phidgetIdArray

	^ self allInstances
		detect: [ :phidget | phidget id == phidgetIdArray ]
		ifNone: [ nil ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:53'!
incrementByteArray: id

	| newId |
	newId := id.
	id size to: 1 by: -1 do: [ :i |
		(newId byteAt: i) < 255
			ifTrue: [ newId at: i put: (newId byteAt: i) +1.
					^ newId ]
			ifFalse: [ newId at: i put: 0 ] ].
	^ newId! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:22'!
initialize
	super initialize.
	currentId := {  0. 0. 0. 0  } asByteArray! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 11:37'!
primClose: phidgetIdArray
	"Close the Phidget with given id. 
	Return 1 if the operation succeeded, or other values otherwise."
	
	^ 1! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:49'!
primGetDeviceClass: phidgetIdArray
	"Answer the device class id of the opened device with given id. Answers -1 if an error occurred."

	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ -1 ]
		ifNotNil: [ phidget mockGetDeviceClass ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:49'!
primGetDeviceName: phidgetIdArray
	"Answer a byte array of the name of the opened device with given id. Answers nil if an error occurred."

	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ nil ]
		ifNotNil: [ phidget mockGetDeviceName ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:48'!
primGetDeviceType: phidgetIdArray
	"Answer the device type id of the opened device with given id. Answers -1 if an error occurred."

	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ -1 ]
		ifNotNil: [ phidget mockGetDeviceType ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:44'!
primGetLabel: phidgetIdArray
	"Answer a byte array of the label of the opened device with given id. Answers nil if an error occurred."

	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ nil ]
		ifNotNil: [ phidget mockGetLabel ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:42'!
primGetNewId

	currentId := self incrementByteArray: currentId.
	^ currentId! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:44'!
primGetSerialNumber: phidgetIdArray
	"Returns the Phidget's serial number, or -1 if there was an error."
	
	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ -1 ]
		ifNotNil: [ phidget mockGetSerialNumber ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 10:44'!
primIsAttached: phidgetIdArray
	"Returns 1 if the Phidget is attached, and other values otherwise."
	
	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	^ phidget
		ifNil: [ nil ]
		ifNotNil: [ phidget mockIsAttached ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 11:37'!
primIsValid: phidgetIdArray
	"Returns 1 if the Phidget id is valid, or other values otherwise."
	
	| phidget |
	phidget := self getPhidgetFromId: phidgetIdArray.
	"if we now have a phidget object, the id is valid"
	^ phidget
		ifNil: [ nil ]
		ifNotNil: [ 1 ]! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 11:36'!
primOpen: phidgetIdArray serial: serial serverAddress: serverAddress port: port password: password
	"Opens the Phidget remotely with the given serial number, server address, port and password.
	Return 1 if the operation succeeded, or other values otherwise."

	^ 1! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 11:36'!
primOpen: phidgetIdArray serial: serial serverID: serverID password: password
	"Opens the Phidget remotely with the given serial number, server ID and password.
	Return 1 if the operation succeeded, or other values otherwise."

	^ 1! !

!PhdMockPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 9/1/2009 11:35'!
primOpen: phidgetIdArray withSerial: serial
	"Opens the Phidget with the given serial number.
	Return 1 if the operation succeeded, or other values otherwise."

	^ 1! !

!PhdMockPhidget methodsFor: 'mock-control' stamp: 'pt 8/31/2009 11:53'!
attached: aBoolean

	attached := aBoolean! !
PhdMockPhidget initialize!
